library(knitr)
library(kableExtra)
library(dplyr)
library(tidyr)
library(ggplot2)
library(rjags)
load.module("dic")
load.module("glm")
load.module("msm")
library(runjags)
runjags.options(silent.jags = FALSE, silent.runjags = FALSE,
  predraw.plots = FALSE, method = "rjparallel")
library(ggmcmc)
##library(devtools)
##load_all("~/est/packages/ggmcmc")
library(gridExtra)
library(GGally)
library(ggrepel)

library(colorspace)

#source("theme.R")
#theme_set(theme_xfim())

library(stringr)
#library(devtools)
#load_all("~/est/packages/PolicyPortfolios")
library(PolicyPortfolios)
library(cowplot)
library(corrplot)
library(scales)
library(forcats)
library(tibble)

# Define also color palettes
# For environmental and social sectors
pal.sector <- c(rgb(0, 149, 64, max = 255), rgb(255, 0, 0, max = 255))
# For Implementation costs and Policy feedback
pal.dimension <- c("#E69F00", "#0072B2")

# simple kable
skable <- function(data) {
    knitr::kable(data, booktabs = TRUE, digits = 3) %>% 
    kable_styling(font_size = 8)
}
# Function to produce nice tables in both latex and html
mykbl <- function(tb, tc = NULL, digits = 2) {
  if (knitr::is_latex_output()) {
    knitr::kable(tb, format = "latex", digits = digits, caption = tc, longtable = TRUE, booktabs = TRUE) %>%
      kable_styling(font_size = 7, latex_options = c("striped"))
  } else {
    knitr::kable(tb, format = "html", digits = 2, caption = tc, booktabs = TRUE) %>%
      kable_styling(font_size = 7, position = "center", bootstrap_options = "striped", full_width = T)
  }
}

cov.rename.reorder <- function(x) {
  # Define covariates order
  cov.order <- c("Issue salience", "Electoral competition", "Institutional fragmentation",
                 "Ideology, average",
                 "Government salience",
                 "Corporatism",
                 "Regional autonomy (shared rule)",
                 "Policy costs (unemployment)", "Policy costs (pensions)",
                 "Policy costs (dummy)",
                 "Administrative reforms",
                 "Size",
                 "Debt (log)",
                 "GDPpc (log)")
  # Relabel
  x <- as.character(x)
  x[x == "Shared rule"] <- "Regional autonomy (shared rule)"
  x[x == "Ideological difference with next government, absolute"] <- "Ideological difference\nbetween governments"
  x[x == "Administrative coordination reforms (n)"] <- "Administrative reforms"
  x[x == "Managerial autonomy"] <- "Politico-administrative separation"
  #x[x == ""] <- ""
  x <- factor(x)
  x <- fct_relevel(x, rev(cov.order))
  return(x)
}


